## open-build-service 2.9.4

=== Makefile ===

MANDIR=$(DESTDIR)/usr/share/man/man6/
BINDIR=$(DESTDIR)/usr/games/

CC=gcc
MKDIR=mkdir -p
INSTALL=install

CFLAGS=-Wall -fomit-frame-pointer -O3
LIBS=-lm -lncurses

OBJS=ctris.o game.o screen.o brick.o highscore.o
OUTPUT=ctris
MANS=ctris.6.gz


all:
	make config
	make build
	
config:	
	./create_config.sh

build: $(OUTPUT)

$(OUTPUT): $(OBJS)
	$(CC) $(CFLAGS) -o $(OUTPUT) $(OBJS) $(LIBS)


%.o: %.c
	$(CC) $(CFLAGS) -c $<


clean:
	$(RM) $(OBJS) $(OUTPUT) config.h


install:
	$(MKDIR) $(BINDIR) $(MANDIR)
	$(INSTALL) $(OUTPUT) $(BINDIR)
	$(INSTALL) -m 644 $(MANS) $(MANDIR)

=== dist/Makefile ===
include ../Makefile.include

INIT_SCRIPTS          := obssrcserver obsrepserver obsscheduler obsworker obspublisher obsdispatcher obssigner obswarden obsapidelayed obsapisetup obsstoragesetup obsservice obsdodup obsservicedispatch obsclouduploadserver obsclouduploadworker
LOGROTATE_CONFIGS     := obs-api obs-server obs-source_service
OBS_BIN_SCRIPTS       := obs_productconvert
OBS_SBIN_SCRIPTS      := obs_admin obs_serverstatus
SYSTEMD_SERVICE_FILES := obsdeltastore

UNITDIR=/usr/lib/systemd/system/

install: install_obsapisetup install_apache install_initscripts install_project_update install_logrotate install_fillups install_slp install_obs_bin install_devel_docs install_overview install_tests_appliance install_crontabs install_systemd_services install_registry_dirs

#install_overview

install_obsapisetup: system_dirs
	$(INSTALL) -m 755 obsapisetup $(DESTDIR)/etc/init.d/obsapisetup
	$(INSTALL) -m 755 setup-appliance.sh $(DESTDIR)$(OBS_BACKEND_PREFIX)/setup-appliance.sh

install_apache:
	$(INSTALL) -d -m 755  $(DESTDIR)$(APACHE_CONIFGDIR_VHOST)
	$(INSTALL) -m 644 $(APACHE_VHOST_CONF) $(DESTDIR)$(APACHE_CONIFGDIR_VHOST)/obs.conf
	$(INSTALL) -m 644 $(APACHE_VHOST_CONTAINER_REGISTRY_CONF) $(DESTDIR)$(APACHE_CONIFGDIR_VHOST)/$(APACHE_VHOST_CONTAINER_REGISTRY_CONF)

install_initscripts: system_dirs
	$(foreach script,$(INIT_SCRIPTS),$(shell $(INSTALL) -m 755 $(script) $(DESTDIR)/etc/init.d/$(script)) )
	$(foreach script,$(INIT_SCRIPTS),$(shell ln -sf /etc/init.d/$(script) $(DESTDIR)/usr/sbin/rc$(script)) )

install_systemd_services: system_dirs
	$(foreach service,$(SYSTEMD_SERVICE_FILES),$(shell $(INSTALL) -m 644 ./systemd/$(service).service $(DESTDIR)$(UNITDIR)$(service).service) )
	$(foreach service,$(SYSTEMD_SERVICE_FILES),$(shell ln -sf /usr/sbin/service $(DESTDIR)/usr/sbin/rc$(service) ) )

install_project_update: system_dirs
	$(INSTALL) -m 0755 obs_project_update $(DESTDIR)/usr/sbin/obs_project_update


install_logrotate: system_dirs
	$(foreach config,$(LOGROTATE_CONFIGS),$(shell $(INSTALL) -m 644 $(config).logrotate $(DESTDIR)/etc/logrotate.d/$(config)) )

install_fillups: system_dirs
	$(INSTALL) -m 0644 sysconfig.obs-server $(DESTDIR)/var/adm/fillup-templates/

install_slp: system_dirs
	$(INSTALL) -m 644 obs.source_server.reg $(DESTDIR)/etc/slp.reg.d/
	$(INSTALL) -m 644 obs.repo_server.reg $(DESTDIR)/etc/slp.reg.d/

install_obs_bin: system_dirs
	$(foreach script,$(OBS_BIN_SCRIPTS),$(shell $(INSTALL) -m 755 $(script) $(DESTDIR)/usr/bin/$(script)) )
	$(foreach script,$(OBS_SBIN_SCRIPTS),$(shell $(INSTALL) -m 755 $(script) $(DESTDIR)/usr/sbin/$(script)) )

install_crontabs:
	$(INSTALL) -m 644 cleanup_scm_cache.cron $(DESTDIR)/etc/cron.d/cleanup_scm_cache
	$(INSTALL) -m 644 obs_api_delayed_jobs_monitor.cron $(DESTDIR)/etc/cron.d/obs_api_delayed_jobs_monitor

system_dirs:
	$(INSTALL) -d -m 755 $(DESTDIR)$(OBS_BACKEND_PREFIX)
	$(INSTALL) -d -m 755 $(DESTDIR)/etc/init.d/
	$(INSTALL) -d -m 755 $(DESTDIR)/etc/logrotate.d/
	$(INSTALL) -d -m 755 $(DESTDIR)/etc/slp.reg.d/
	$(INSTALL) -d -m 755 $(DESTDIR)/etc/cron.d/
	$(INSTALL) -d -m 755 $(DESTDIR)/usr/bin/
	$(INSTALL) -d -m 755 $(DESTDIR)/usr/sbin/
	$(INSTALL) -d -m 755 $(DESTDIR)/var/adm/fillup-templates
	$(INSTALL) -d -m 755 $(DESTDIR)/usr/share/doc/packages/obs-devel
	$(INSTALL) -d -m 755 $(DESTDIR)/usr/lib/obs/tests/appliance
	$(INSTALL) -d -m 755 $(DESTDIR)$(UNITDIR)

install_devel_docs:
	$(INSTALL) -m 644 README.devel $(DESTDIR)/usr/share/doc/packages/obs-devel/README.devel

install_overview:
	$(INSTALL) -d -m 755 $(DESTDIR)$(OBS_DOCUMENT_ROOT)/overview
	$(INSTALL) -m 644 overview.html.TEMPLATE $(DESTDIR)$(OBS_DOCUMENT_ROOT)/overview

install_registry_dirs:
	mkdir -p $(DESTDIR)/srv/www/obs/container-registry{,/log,/htdocs}

install_tests_appliance:
	cp -r ./t/*	$(DESTDIR)/usr/lib/obs/tests/appliance/

test_unit:
	prove -v t/*.t

test_system:
	prove -v t/*.ts

test_appliance:
	prove -v t/*.ta

.PHONY: test_unit test_system

=== src/api/Makefile ===
include ../../Makefile.include


OBS_API_LOGS := access.log backend_access.log delayed_job.log error.log lastevents.access.log

all:

install: prepare_dirs prepare_rake docs config log_files build

prepare_dirs:
	$(INSTALL) -d -m 755 $(DESTDIR)$(OBS_API_PREFIX)
	$(INSTALL) -d -m 755 $(DESTDIR)$(OBS_API_PREFIX)/log
	$(INSTALL) -d -m 755 $(DESTDIR)$(OBS_API_PREFIX)/tmp
	$(INSTALL) -d -m 755 $(DESTDIR)$(OBS_API_PREFIX)/config
	# prepare for running sphinx daemon
	$(INSTALL) -m 0755 -d $(DESTDIR)$(OBS_API_PREFIX)/db/sphinx{,/production}

prepare_rake: prepare_dirs
	cp -a * $(DESTDIR)$(OBS_API_PREFIX)
	rm $(DESTDIR)$(OBS_API_PREFIX)/Makefile
	rm $(DESTDIR)$(OBS_API_PREFIX)/Procfile
	touch $(DESTDIR)$(OBS_API_PREFIX)/log/production.log
	touch $(DESTDIR)$(OBS_API_PREFIX)/config/production.sphinx.conf

docs:
	$(INSTALL) -d -m 755 $(DESTDIR)$(OBS_APIDOCS_PREFIX)/api
	$(INSTALL) -d -m 755 $(DESTDIR)$(OBS_APIDOCS_PREFIX)/api/html
	cp -av ../../docs/api/api $(DESTDIR)$(OBS_APIDOCS_PREFIX)
	cp -av ../../docs/api/html/* $(DESTDIR)$(OBS_APIDOCS_PREFIX)/api/html/
	ln -sf $(OBS_APIDOCS_PREFIX)/api/ $(DESTDIR)$(OBS_API_PREFIX)/public/schema
	echo 'CONFIG["apidocs_location"] ||= File.expand_path("../docs/api/html/")' >> $(DESTDIR)$(OBS_API_PREFIX)/config/environment.rb
	echo 'CONFIG["schema_location"] ||= File.expand_path("../docs/api/")' >> $(DESTDIR)$(OBS_API_PREFIX)/config/environment.rb

config: prepare_dirs
	# we need config also in building environment, otherwise rake will break
	$(INSTALL) -m 644  config/database.yml.example 				config/database.yml
	$(INSTALL) -m 644  config/options.yml.example 				config/options.yml
	$(INSTALL) -m 644 config/thinking_sphinx.yml.example 	config/thinking_sphinx.yml
	# TODO: see if these configuration work in real life
	$(INSTALL) -m 644  config/database.yml.example 				$(DESTDIR)$(OBS_API_PREFIX)/config/database.yml
	$(INSTALL) -m 644  config/options.yml.example 				$(DESTDIR)$(OBS_API_PREFIX)/config/options.yml
	$(INSTALL) -m 644 config/thinking_sphinx.yml.example 	$(DESTDIR)$(OBS_API_PREFIX)/config/thinking_sphinx.yml
	echo "# This is to prevent fdupes from hardlinking" >> $(DESTDIR)$(OBS_API_PREFIX)/config/database.yml
	echo "# This is to prevent fdupes from hardlinking" >> $(DESTDIR)$(OBS_API_PREFIX)/config/options.yml
	echo "# This is to prevent fdupes from hardlinking" >> $(DESTDIR)$(OBS_API_PREFIX)/config/thinking_sphinx.yml

log_files:
	$(foreach logfile,$(OBS_API_LOGS),$(shell touch $(DESTDIR)$(OBS_API_PREFIX)/log/$(logfile) ))

build: config
	$(shell [ -d $(DESTDIR)/srv/www/obs/api/.bundle ] && rm -rf $(DESTDIR)/srv/www/obs/api/.bundle)
	# we need to have *something* as secret key
	echo "" | sha256sum| cut -d\  -f 1 > $(DESTDIR)/srv/www/obs/api/config/secret.key
	cd $(DESTDIR)/srv/www/obs/api ;\
	bundle.ruby2.5 exec rake.ruby2.5 assets:precompile RAILS_ENV=production RAILS_GROUPS=assets || exit 1 ;\
	rm -rf tmp/cache/sass tmp/cache/assets config/secret.key ;\
	bundle.ruby2.5 config --local frozen 1 || exit 1 ;\
	bundle.ruby2.5 config --local without development:test:assets || exit 1 ;\
	# reinstall
	$(INSTALL) config/database.yml.example $(DESTDIR)$(OBS_API_PREFIX)/config/database.yml
	# patch our version inside
	sed -i -e 's,^api_version.*,api_version = "$(OBS_VERSION)",'  $(DESTDIR)$(OBS_API_PREFIX)/config/initializers/02_apiversion.rb

test_unit:
	[ -d log ] || mkdir log
	echo > log/test.log
	./script/api_test_in_spec.sh
clean:
	rm -rf ../../docs/api/html

.PHONY: test

=== src/backend/Makefile ===
include ../../Makefile.include

OBS_BACKEND_DATA_SUBDIRS := build events info jobs log projects repos run sources trees workers
OBS_BACKEND_DATA_DIR := /srv/obs

prepare_dirs:
	$(INSTALL) -d -m 755 $(DESTDIR)$(OBS_BACKEND_PREFIX)
	$(INSTALL) -d -m 755 $(DESTDIR)$(OBS_BACKEND_DATA_DIR)

bs_config:
	[ -f ./BSConfig.pm ] || cp ./BSConfig.pm.template ./BSConfig.pm
	

install: prepare_dirs install_data_dirs bs_config
	# prevent error while copy if there is an previous installation
	rm -rf $(DESTDIR)$(OBS_BACKEND_PREFIX)/build
	cp -a ./* $(DESTDIR)$(OBS_BACKEND_PREFIX)
	rm -rf $(DESTDIR)$(OBS_BACKEND_PREFIX)/build
	rm -rf $(DESTDIR)$(OBS_BACKEND_PREFIX)/Makefile
	rm -rf $(DESTDIR)$(OBS_BACKEND_PREFIX)/t
	rm -rf $(DESTDIR)$(OBS_BACKEND_PREFIX)/testdata
	rm -rf $(DESTDIR)$(OBS_BACKEND_PREFIX)/examples
	# just for check section, it is a %%ghost
	ln -sf /usr/lib/build $(DESTDIR)$(OBS_BACKEND_PREFIX)/build 

install_data_dirs: prepare_dirs
	$(foreach data_dir,$(OBS_BACKEND_DATA_SUBDIRS), \
		$(shell $(INSTALL) -d -m 755 $(DESTDIR)$(OBS_BACKEND_DATA_DIR)/$(data_dir) ) \
	)


test_unit: bs_config clean_cover
	rm -rf t/tmp/*
	PERL5OPT=-MDevel::Cover LANG=C prove -Ibuild -I. -v t/*.t

cover: test_unit
	cover -ignore_re '^((build|XML|t)/|/usr/bin/prove$$)' -outputdir /srv/www/htdocs

clean_cover:
	rm -rf cover_db/

.PHONY: test_unit cover

=== dist/t/osc/Makefile ===
check:
	@for i in *.ts; do perl -c $$i; done

test_system:
	prove -v *.ts

=== docs/api/api/Makefile ===
all:
	@echo "Targets: test apidocs"

test:
	../restility/bin/rest_test api.txt
	
apidocs:
	BUNDLE_GEMFILE=../../../src/api/Gemfile bundle exec ../restility/bin/rest_doc api.txt --html -o ../html

=== docs/api/backend/Makefile ===
all:
	@echo "Targets: test apidocs"

test:
	RUBYLIB=../restility/lib ../restility/bin/rest_test -I .. api.txt
	
apidocs:
	RUBYLIB=../restility/lib ../restility/bin/rest_doc -I .. api.txt --html -o html

=== debian/changelog ===
open-build-service (2.9.4-2) unstable; urgency=medium

  * Make obs-api runtime depends on ruby-coffee-rails

 -- Lucas Kanashiro <kanashiro@debian.org>  Mon, 18 Mar 2019 16:47:17 -0300

open-build-service (2.9.4-1) unstable; urgency=medium

  [ Dan Nicholson ]
  * debian/control: Add Vcs-* links.

  [ Andrew Lee (李健秋) ]
  * New upstream release version 2.9.4. Closes: #918402, #903797, #903796.
    Fixes: CVE-2018-12467, CVE-2018-7689, CVE-2018-7688.
  * Refreshed use-ruby2.5.patch.
  * Refresh gemfile-tweaks.patch. Dropped embedded gem.
  * Drop drop-test-and-development-depends.patch.
  * Drop drop-ruby-hoptoad-notifier.patch.
  * Drop rails-4-gem-assets.patch.
  * Refreshed FHS-path.patch.
  * Refreshed and rename to do-not-install-fillups-and-initscripts.patch.
  * Drop Rakefile-fix.patch.
  * Drop fix-privacy-breach-piwik.patch.
  * Refreshed jquery-ui.patch.
  * Refreshed Do-not-ship-database.yml.patch.
  * Drop localgem.patch.
  * Drop CVE-2017-5188.patch.
  * Drop fix-kiwitree-symlink.patch.
  * Drop handle-links-properly.patch.
  * Drop dist-Use-2.7-packages-for-testing.patch.
  * debian/control: build-deps on rails (>= 5.1.1).
  * Drop airbrake, airbrake-ruby and it's related code.
  * Drop peek-dalli and peek-mysql2.
  * Adjust new build-deps.
  * Refresh gemfile-tweaks.patch.
  * Added do-not-run-rake-at-build-time.patch.
  * Added obsdeltastore.service file.
  * Install missing files.

  [ Lucas Kanashiro ]
  * debian/copyright: remove symlink from listed files
  * Drop debian/missing-sources
  * Remove the debian/localgem directory
  * Do not depend or recommend obsolete packages
  * Build depends on python instead of python-dev
  * Improve the obs-api package description
  * Use dh_missing to list missing files
  * Update config files copied to /etc
  * Call dh_install even overriding it
  * Add jquery.js missing source
  * Add patch to not allow one to load external JS in runtime
  * Runtime depends on libjs-html5shiv
  * Do not use recursive chown
  * Fix the script's perl interpreter path
  * Make obs-api runtime depends on adduser
  * Add some basic autopkgtests
  * debian/obs-api.postinst: enable obs apache2 site config
  * Use deb-systemd-invoke instead of invoke-rc.d
  * d/obs-server.postrm: check if group exists before remove it
  * Do not move database.yml.example to /etc

  [ Andrew Lee (李健秋) ]
  * No signd support by default in Debian OBS.
  * Adjust permissions for obs 2.9 rails app.

  [ Lucas Kanashiro ]
  * Add another basic autopkgtest
  * Add my self to Uploaders
  * Add patch fixing CVE-2018-12479. Closes: #911797
  * Do not enable obsworker service when it is installed
  * Do not install empty directory in obs-server package
  * Do not install empty directory in obs-api package
  * Declare compliance with Debian Policy 4.3.0
  * Add Vcs-{Git,Browser} fields

  [ Lucas Kanashiro ]
  * Update debian/changelog
  * debian/changelog: add missing entries

  [ Andrew Lee (李健秋) ]
  * Refine changlog to have Dan Nicholson's change on top

  [ Lucas Kanashiro ]
  * Remove duplicated VCS links
  * d/rake-tasks.sh: do not chown non existent file
  * d/patch/CVE-2018-12479.patch: use APIException
  * d/rake-tasks.sh: run ts:index task using production env

  [ Andrew Lee (李健秋) ]
  * d/rake-tasks.sh: touch the file if it's not exist yet for chown
    command.
  * Refreshed obsapidelayed init script changes from upstream.
  * Fix minor code style mistake in obsapidelayed init script.
  * Clean up mistake in refreshed obsapidelayed init script.
  * debian/control: obs-worker depends on tar. (Closes:#917427)
  * Added systemd obsapidelayed.service file.
  * Added systemd obsworker@.service file. (Closes:#853161)
  * debian/README.Debian: added how to run worker with systemd.
  * Added versioned depends on tar to avoid lintien error.
  * debian/obs-api.postinst: add a fallback hostname to make it installs
    in autopkgtest.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Thu, 07 Feb 2019 16:51:58 +0800

open-build-service (2.7.4-3) unstable; urgency=medium

  [ Héctor Orón Martínez ]
  * Embed sanitize 4.0.0 ruby gem to fix breakeage.
    - add obs-api runtime depends on ruby-nokogumbo and ruby-crass.
  * worker: document enable switch
  * worker: use /var/lib/obsworker as OBS_RUN_DIR

  [ Andrew Lee (李健秋) ]
  * debian/gbp.conf: adjust gbp configuration file.
  * obs-worker: depends on fdisk | util-linux (<< 2.29.2-3~). (Closes:
    #872093)
  * CVE-2017-5188.patch: Apply upstream fixes for
    CVE-2017-5188.(Closes:#900133)
  * fix-kiwitree-symlink.patch: cherry-pick bad code fix from upstream.
  * Handle links properly when doing backend build operations.
  * Make passenger rubyapp runs as obsapi user.
  * Update correct group permission for rb_sysopen.

  [ Lucas Kanashiro ]
  * Remove patches related to ruby2.3.
  * Add patch to use ruby provided by the system instead of ruby2.3.
    (Closes:#894778)

  [ Andrew Lee (李健秋) ]
  * Drop superseded dh-systemd with debhelper (>= 9.20160709).
  * Add missing fix-sphinx.patch into series file.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Thu, 13 Sep 2018 15:00:41 +0800

=== debian/control ===
Source: open-build-service
Section: devel
Priority: optional
Maintainer: Debian Ruby Extras Maintainers <pkg-ruby-extras-maintainers@lists.alioth.debian.org>
Uploaders: Andrew Lee (李健秋) <ajqlee@debian.org>,
           Héctor Orón Martínez <zumbi@debian.org>,
           Lucas Kanashiro <kanashiro@debian.org>
Build-Depends: debhelper (>= 9.20160709),
               bundler,
               fdupes,
               libbssolv-perl,
               default-mysql-server | virtual-mysql-server,
               python,
               rails (>= 5.1.1),
               rake (>=12.3.0),
               ruby-actionview,
               ruby-activemodel-serializers-xml,
               ruby-acts-as-list,
               ruby-acts-as-tree,
               ruby-addressable,
               ruby-bcrypt,
               ruby-bunny,
               ruby-capybara,
               ruby-chunky-png,
               ruby-cliver,
               ruby-clockwork,
               ruby-cocoon,
               ruby-codemirror-rails,
               ruby-coderay,
               ruby-coffee-rails,
               ruby-colorize,
               ruby-crack,
               ruby-cssmin,
               ruby-daemons,
               ruby-dalli,
               ruby-database-cleaner,
               ruby-data-migrate (>= 5.3.1),
               ruby-delayed-job,
               ruby-delayed-job-active-record,
               ruby-docile,
               ruby-erubis,
               ruby-escape-utils,
               ruby-execjs,
               ruby-feature,
               ruby-flot-rails,
               ruby-font-awesome-rails,
               ruby-gssapi,
               ruby-haml,
               ruby-hike,
               ruby-i18n,
               ruby-innertube,
               ruby-joiner (>= 0.4.2),
               ruby-jquery-datatables-rails,
               ruby-jquery-rails,
               ruby-jquery-ui-rails,
               ruby-json,
               ruby-kaminari,
               ruby-kgio,
               ruby-ldap,
               ruby-metaclass,
               ruby-method-source,
               ruby-middleware,
               ruby-mime-types,
               ruby-momentjs-rails,
               ruby-mousetrap-rails,
               ruby-mysql2,
               ruby-nokogiri,
               ruby-parser,
               ruby-peek,
               ruby-pkg-config (>= 1.1.6),
               ruby-pundit,
               ruby-rails,
               ruby-rails-tokeninput,
               ruby-raindrops,
               ruby-redcarpet,
               ruby-responders,
               ruby-riddle (>= 2.3.1),
               ruby-safe-yaml,
               ruby-sanitize,
               ruby-sass,
               ruby-sass-rails,
               ruby-sexp-processor,
               ruby-simplecov,
               ruby-slop,
               ruby-sprite-factory,
               ruby-sprockets,
               ruby-temple,
               ruby-thinking-sphinx (>= 4.1.0-2),
               ruby-thread-safe,
               ruby-tzinfo,
               ruby-uglifier,
               ruby-voight-kampff,
               ruby-websocket-driver,
               ruby-xmlhash,
               ruby-xpath,
               ruby-yajl,
               rubygems-integration,
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/ruby-team/open-build-service.git
Vcs-Browser: https://salsa.debian.org/ruby-team/open-build-service
Homepage: http://en.opensuse.org/Build_Service

Package: obs-server
Architecture: all
Depends: apt-utils,
         adduser,
         diffutils,
         git,
         libbssolv-perl,
         libcompress-raw-zlib-perl,
         libfile-sync-perl,
         libjson-xs-perl,
         libnet-ssleay-perl,
         libsocket-msghdr-perl,
         libxml-parser-perl,
         libxml-simple-perl,
         obs-build,
         obs-productconverter (>= ${binary:Version}),
         patch,
         reprepro,
         sysvinit-utils (>= 2.88dsf-59),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: createrepo,
            dpkg-dev,
            gnupg2,
            lvm2,
            obs-signd,
            slpd,
            yum
Description: Open Build Service (server component)
 The Open Build Service (OBS) backend is used to store all sources and
 binaries. It also calculates the need for new build jobs and distributes
 it.

Package: obs-worker
Architecture: all
Depends: apt-utils,
         adduser,
         binutils,
         tar (>= 1.27),
         cpio,
         curl,
         debootstrap,
         fdisk | util-linux (<< 2.29.2-3~),
         libcompress-raw-zlib-perl,
         libtimedate-perl,
         libxml-parser-perl,
         libxml-simple-perl,
         lsb-base (>= 3.0-6),
         lvm2,
         lzma,
         psmisc,
         rpm,
         screen,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Open Build Service (build host component)
 This is the obs build host, to be installed on each machine building
 packages in this obs installation. Install it alongside obs-server to
 run a local playground test installation.

Package: obs-api
Architecture: all
Depends: adduser,
         apache2,
         dbconfig-common,
         gsfonts,
         libapache2-mod-passenger,
         libapache2-mod-xforward,
         libgd-gd2-perl,
         libjs-bootstrap,
         libjs-html5shiv,
         lsb-base (>= 3.0-6),
         memcached,
         default-mysql-client | virtual-mysql-client,
         ruby,
         ruby-activemodel-serializers-xml,
         ruby-acts-as-list,
         ruby-acts-as-tree,
         ruby-addressable,
         ruby-bcrypt,
         ruby-bunny,
         ruby-capybara,
         ruby-chunky-png,
         ruby-cliver,
         ruby-clockwork,
         ruby-cocoon,
         ruby-codemirror-rails,
         ruby-coderay,
         ruby-coffee-rails,
         ruby-colorize,
         ruby-crack,
         ruby-crass,
         ruby-cssmin,
         ruby-daemons,
         ruby-dalli,
         ruby-data-migrate,
         ruby-delayed-job,
         ruby-delayed-job-active-record,
         ruby-docile,
         ruby-erubis,
         ruby-escape-utils,
         ruby-execjs,
         ruby-feature,
         ruby-flot-rails,
         ruby-font-awesome-rails,
         ruby-gssapi,
         ruby-haml,
         ruby-hike,
         ruby-i18n,
         ruby-innertube,
         ruby-joiner  (>= 0.4.2),
         ruby-jquery-datatables-rails,
         ruby-jquery-rails,
         ruby-jquery-ui-rails (>= 6.0.1),
         ruby-json,
         ruby-kaminari,
         ruby-kgio,
         ruby-ldap,
         ruby-metaclass,
         ruby-method-source,
         ruby-middleware,
         ruby-mime-types,
         ruby-momentjs-rails,
         ruby-mousetrap-rails,
         ruby-mysql2,
         ruby-nokogiri,
         ruby-nokogumbo,
         ruby-parser,
         ruby-peek,
         ruby-pkg-config (>= 1.1.6),
         ruby-pundit,
         ruby-rails,
         ruby-rails-tokeninput,
         ruby-raindrops,
         ruby-redcarpet,
         ruby-responders,
         ruby-riddle (>= 2.3.1),
         ruby-safe-yaml,
         ruby-sanitize,
         ruby-sass,
         ruby-sass-rails,
         ruby-sexp-processor,
         ruby-slop,
         ruby-sprite-factory,
         ruby-sprockets,
         ruby-temple,
         ruby-thinking-sphinx (>= 4.1.0-2),
         ruby-thread-safe,
         ruby-tzinfo,
         ruby-uglifier,
         ruby-voight-kampff,
         ruby-websocket-driver,
         ruby-xmlhash,
         ruby-xpath,
         ruby-yajl,
         rubygems-integration,
         sphinxsearch (>= 2.0.8),
         unicorn,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: default-mysql-server
Suggests: obs-server
Breaks: obs-server (<= 2.7.1-3)
Provides: obs-webui
Description: Open Build Service (API)
 This is the API server instance for the OBS. It is a Ruby on Rails application
 that enables interaction via a web interface and a Resful API.

Package: obs-productconverter
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Open Build Service (product definition utility)
 The obs_productconvert is a utility to create Kiwi- and Spec- files
 from a product definition.

Package: obs-utils
Architecture: all
Depends: osc,
         ruby,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Open Build Service (utilities)
 The obs-utils contains tools for Open Build Service. Including:
  * obs_mirror_project - a tool to copy the binary data of a project
    from one obs to another.
  * obs_project_update - a tool to copy a packages of a project from
    one obs to another.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DH_OPTIONS

export BUILD_ROOT=$(CURDIR)/debian/tmp

%:
	dh $@ --parallel --with=systemd

override_dh_auto_build:
	# Drop Gemfile.lock
	rm -f src/api/Gemfile.lock
	dh_auto_build

override_dh_install:
	dh_install
	# Drop useless files.
	rm -f debian/tmp/etc/apache2/vhosts.d/obs.conf
	rm -f debian/tmp/etc/init.d/obsapisetup
	rm -f debian/tmp/usr/lib/obs/server/build/build exists
	rm -f debian/tmp/usr/share/doc/packages/obs-devel/README.devel

	dh_missing --list-missing

	dh_installdebconf

	# Move config files under /etc/obs/api/config/. And links with dh_link.
	mv debian/obs-api/usr/share/obs/api/config/options.yml.example \
			debian/obs-api/etc/obs/api/config/options.yml
	mv debian/obs-api/usr/share/obs/api/config/thinking_sphinx.yml.example \
			debian/obs-api/etc/obs/api/config/thinking_sphinx.yml

	# Remove log and tmp and create links under /var with dh_link.
	rm -rf debian/obs-api/usr/share/obs/api/log
	rm -rf debian/obs-api/usr/share/obs/api/tmp

	# Rename dh_install installed web service config files.
	# (new default since OBS 2.3)
	mkdir -p debian/obs-api/etc/apache2/sites-available/
	cp debian/obs-apache2.conf \
		debian/obs-api/etc/apache2/sites-available/obs.conf

	mkdir -p debian/obs-api/usr/share/dbconfig-common/data/obs-api/install/
	touch debian/obs-api/usr/share/dbconfig-common/data/obs-api/install/mysql
	cp debian/obs-server/usr/lib/obs/server/BSConfig.pm.template \
		debian/obs-server/etc/obs/BSConfig.pm

	# Rename sysconfig file
	mv debian/obs-server/etc/default/sysconfig.obs-server \
		debian/obs-server/etc/default/obs-server

	# turn duplicates into hard links
	fdupes debian/obs-api/usr/share/obs/

	# Clean up vcs control file
	find debian/obs-api -name '.gitignore' -type f | xargs rm -f

	# Replace #!/usr/bin/env perl to #!/usr/bin/perl
	grep -rl '/usr/bin/env perl' debian/ | xargs sed -i 's#/usr/bin/env perl#/usr/bin/perl#'

	# fix permissions
	chmod a-x debian/obs-api/usr/share/obs/api/script/update_bento.sh
	chmod a-x debian/obs-api/usr/share/obs/api/Rakefile
	# Clean up "extra" license
	rm debian/obs-server/usr/lib/obs/server/License

	# Fix Mark scripts as executable until upstream fixes
	chmod a+x debian/obs-server/usr/lib/obs/tests/appliance/*t*

	# Remove useless Gemfile.lock
	rm -f debian/obs-api/usr/share/obs/api/Gemfile.lock

	# Do not install empty directory, this directory will be used only by the rake-tasks.sh
	rm -rf debian/obs-api/usr/share/obs/api/db/sphinx

override_dh_systemd_enable:
	dh_systemd_enable -p obs-server \
		obsdeltastore.service \
		obsrepserver.service \
		obssrcserver.service \
		obsdispatcher.service \
		obswarden.service \
		obsdodup.service \
		obspublisher.service \
		obssigner.service
	dh_systemd_enable -p obs-api obsapidelayed.service

override_dh_installinit:
	dh_installinit --name obsapidelayed --no-start
	dh_installinit --name obsworker --no-enable

override_dh_systemd_start:
	dh_systemd_start -p obs-server \
		obsdeltastore.service \
		obsrepserver.service \
		obssrcserver.service \
		obsdispatcher.service \
		obswarden.service \
		obsdodup.service \
		obspublisher.service \
		obssigner.service
	dh_systemd_start -p obs-api obsapidelayed.service

override_dh_auto_test:
	 dh_auto_test || true # temporary ignore

=== debian/tests/control ===
Test-Command: /bin/true
Depends: obs-api, obs-server, obs-worker, obs-productconverter, obs-utils

Tests: install-purge-install
Depends: obs-api, obs-server, obs-worker, obs-productconverter, obs-utils
Restrictions: needs-root

Tests: install-break-purge
Depends: obs-api, obs-server, obs-worker, obs-productconverter, obs-utils
Restrictions: needs-root
